package parsers

import models.User
import java.util.List
import java.util.Collection
import java.util.ArrayList
import models.Activity
import com.bethecoder.ascii_table.impl.CollectionASCIITableAware
import com.bethecoder.ascii_table.ASCIITable

class AsciiParser extends Parser
{
  override renderUser(User user)
  {
    val List<User> userList = new ArrayList()
    userList.add(user)
    renderUsers(userList)
  }
  
  override renderActivities(Collection<Activity> activities)
  {
    if (!activities.empty)
    {
      val List<Activity> activityList = new ArrayList(activities)
      var activitiesTable = new CollectionASCIITableAware<Activity>(activityList, "id", "type", "location", "distance", "starttime", "duration", "route")
      ASCIITable.getInstance().getTable(activitiesTable)
    }
  }
  
  override renderUsers(Collection<User> users)
  {
    if (!users.empty)
    {
      val List<User> userList = new ArrayList(users)
      var asciiTableAware = new CollectionASCIITableAware<User>(userList, "id", "firstname", "lastname", "email", "password")
      ASCIITable.getInstance().getTable(asciiTableAware);
    }
  } 
}
