package utils

import org.joda.time.format.PeriodFormatterBuilder
import org.joda.time.format.DateTimeFormat
import org.joda.time.DateTime
import org.joda.time.Duration

class DateTimeFormatters
{
  static val periodFormatter = new PeriodFormatterBuilder().printZeroAlways()
                                                                  .appendHours()
                                                                  .appendSeparator(":")
                                                                  .appendMinutes()
                                                                  .appendSeparator(":")
                                                                  .appendSeconds()
                                                                  .toFormatter();

  static val dateFormatter = DateTimeFormat.forPattern("dd:MM:yyyy HH:mm:ss");

  def static parseDateTime (String dateTime)
  {
    new DateTime(dateFormatter.parseDateTime(dateTime))
  }
  
  def static parseDateTime (DateTime dateTime)
  {
    dateFormatter.print(dateTime)
  }
  
  def static parseDuration (String duration)
  {
  	periodFormatter.parsePeriod(duration).toStandardDuration
  }
  
  def static parseDuration (Duration duration)
  {
    periodFormatter.print(duration.toPeriod)
  }
}
