package utils

import com.thoughtworks.xstream.XStream;
import com.thoughtworks.xstream.io.xml.DomDriver;

import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.util.Deque
import java.util.ArrayDeque

class XMLSerializer implements Serializer
{
  var Deque<Object> stack = new ArrayDeque
  val File file;
  
  new (String filename)
  {
    this.file = new File(filename + '.xml');
  }
  
  def override void push(Object o)
  {
    stack.push(o)
  }
  
  def override Object pop()
  {
    return stack.pop();
  }
  
  @SuppressWarnings("unchecked")
  def override void read() 
  {
    var ObjectInputStream is = null

    try
    {
      val xstream = new XStream(new DomDriver())
      is = xstream.createObjectInputStream(new FileReader(file))
      stack = is.readObject as Deque<Object>
    }
    finally
    {
      if (is != null)
      {
        is.close();
      }
    }
  }

  def override void write() 
  {
    var ObjectOutputStream os = null

    try
    {
      val xstream = new XStream(new DomDriver())
      os = xstream.createObjectOutputStream(new FileWriter(file))
      os.writeObject(stack)
    }
    finally
    {
      if (os != null)
      {
        os.close
      }
    }
  }  
} 