package controllers

import static org.junit.Assert.*
import org.junit.Test
import org.junit.Before
import org.junit.After
import controllers.PacemakerAPI
import static models.Fixtures.*
import java.io.File
import utils.XMLSerializer
import utils.Serializer
import static utils.DateTimeFormatters.*
import utils.JSONSerializer

class PersistenceTest 
{
  var PacemakerAPI pacemaker
  var Serializer   xmlSerializer
  var Serializer   jsonSerializer
  val datastoreFile = "testdatastore";
  
  def void deleteFile(String fileName)
  {
    val datastore = new File (fileName)
    if (datastore.exists)
    {
      datastore.delete
    }
  }
  
  def void populate()
  {
    users.forEach [pacemaker.createUser(firstname, lastname, email, password)] 
    
    val marge = pacemaker.getUser("marge@simpson.com")
    margesActivities.forEach[ pacemaker.createActivity(marge.id, type, location, distance, parseDateTime(starttime), parseDuration(duration)) ]
    
    locations.forEach[ pacemaker.addLocation(marge.activities.values.get(0).id, latitude, longitude)]
    
    val lisa = pacemaker.getUser("lisa@simpson.com")
    lisasActivities.forEach[ pacemaker.createActivity(lisa.id, type, location, distance, parseDateTime(starttime), parseDuration(duration)) ]
  }
  
  @Before
  def void setup()
  {
    deleteFile (datastoreFile);
    xmlSerializer = new XMLSerializer(datastoreFile)
    jsonSerializer = new JSONSerializer(datastoreFile)
    pacemaker = new PacemakerAPI
    populate
  }
  
  @After
  def void tearDown()
  {
    pacemaker = null
    xmlSerializer = null
    jsonSerializer = null
   // deleteFile (datastoreFile);
  }
  
  @Test def void testXMLSerializer() 
  { 
  	pacemaker.serializer = xmlSerializer
    pacemaker.store
    val pacemaker2 =  new PacemakerAPI
    pacemaker2.serializer = xmlSerializer
    pacemaker2.load
    pacemaker.users.forEach [assertTrue(pacemaker2.users.contains(it))]
  }
  
   @Test def void testJSONSerializer() 
  { 
    pacemaker.serializer = jsonSerializer
    pacemaker.store
    val pacemaker2 =  new PacemakerAPI
    pacemaker2.serializer = jsonSerializer
    pacemaker2.load
    pacemaker.users.forEach [assertTrue(pacemaker2.users.contains(it))]
  }
}