package models

import static org.junit.Assert.*
import org.junit.Test
import org.joda.time.DateTime
import org.joda.time.Duration

class ActivityTest
{
  val activityStr = 'Activity [
  _id = 0
  _type = "walk"
  _location = "fridge"
  _distance = 0.001
  _starttime = 2013-05-12T09:30:00.000+01:00
  _duration = PT500S
  _route = ArrayList ()
]' 
   
  val activity = new Activity (0l, "walk",  "fridge", 0.001, new DateTime(2013, 5, 12, 9,  30), new Duration (500000));
   
  @Test def void testCreate()
  {
    assertEquals ("walk",          activity.type);
    assertEquals ("fridge",        activity.location);
    assertEquals (0.0001, 0.001,   activity.distance);    
  }  
  
  @Test def void testToString()
  {
    assertEquals (activityStr, activity.toString)
  }

  @Test def void testRoute()
  {
    val activity1 = new Activity (0l, "walk",  "work", 1.1, new DateTime(2013, 5, 12, 9,  30), new Duration (10000));
    
    activity1.route.add(new Location(23.3f, 33.3f))
    activity1.route.add(new Location(23.4f, 34.4f))
    activity1.route.add(new Location(23.5f, 35.5f))

    val activity2 = new Activity (0l, "walk",  "work", 1.1, new DateTime(2013, 5, 12, 9,  30), new Duration (10000));
    
    activity2.route.add(new Location(23.3f, 33.3f))
    activity2.route.add(new Location(23.4f, 34.4f))
    activity2.route.add(new Location(23.5f, 35.5f))

    val activity3 = new Activity (0l, "walk",  "work", 1.1, new DateTime(2013, 5, 14, 10,  45), new Duration (50000));
    
    activity3.route.add(new Location(23.3f, 33.3f))
    activity3.route.add(new Location(43.4f, 54.4f))
    activity3.route.add(new Location(53.5f, 35.5f))
  
    assertEquals (activity1, activity2);
    assertNotEquals(activity1, activity3)
  }

}
